'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*-~-~-~-~-~-~-~-~-~-~- Create an AudioContext Node -~-~-~-~-~-~-~-~-~-~-*/
var createGlobalAudioContext = exports.createGlobalAudioContext = function createGlobalAudioContext() {
  return {
    type: 'CREATE_AUDIO_CONTEXT'
  };
};

/*-~-~-~-~-~-~-~-~-~-~-~-~-~- Create Source Nodes -~-~-~-~-~-~-~-~-~-~-~-~-~-*/
var createOscillator = exports.createOscillator = function createOscillator(name) {
  return {
    type: 'CREATE_OSCILLATOR',
    name: name
  };
};

var createBufferSource = exports.createBufferSource = function createBufferSource(name) {
  return {
    type: 'CREATE_BUFFER_SOURCE',
    name: name
  };
};

/*-~-~-~-~-~-~-~-~-~-~-~-~-~- Create Audio Nodes -~-~-~-~-~-~-~-~-~-~-~-~-~-*/
var createGain = exports.createGain = function createGain(name) {
  return {
    type: 'CREATE_GAIN',
    name: name
  };
};

var createBiquadFilter = exports.createBiquadFilter = function createBiquadFilter(name) {
  return {
    type: 'CREATE_BIQUAD_FILTER',
    name: name
  };
};

var createConvolver = exports.createConvolver = function createConvolver(name) {
  return {
    type: 'CREATE_CONVOLVER',
    name: name
  };
};

var createDelay = exports.createDelay = function createDelay(name, maxDelayTime) {
  return {
    type: 'CREATE_DELAY',
    name: name,
    maxDelayTime: maxDelayTime
  };
};

/*-~-~-~-~-~-~-~-~-~-~-~- AudioContext Methods -~-~-~-~-~-~-~-~-~-~-~-*/
var suspendAudioContext = exports.suspendAudioContext = function suspendAudioContext() {
  return {
    type: 'SUSPEND_AUDIO_CONTEXT'
  };
};

var resumeAudioContext = exports.resumeAudioContext = function resumeAudioContext() {
  return {
    type: 'RESUME_AUDIO_CONTEXT'
  };
};

var closeAudioContext = exports.closeAudioContext = function closeAudioContext() {
  return {
    type: 'CLOSE_AUDIO_CONTEXT'
  };
};

/*-~-~-~-~-~-~-~-~-~-~-~- Source Node Methods -~-~-~-~-~-~-~-~-~-~-~-*/
var oscillatorStart = exports.oscillatorStart = function oscillatorStart(name, time) {
  return {
    type: 'START_SOURCE_NODE',
    name: name,
    time: time
  };
};

/*-~-~-~-~-~-~-~-~-~-~-~- Audio Node Methods -~-~-~-~-~-~-~-~-~-~-~-*/
var connectAudioNodes = exports.connectAudioNodes = function connectAudioNodes(connectThisNode, toThatNode) {
  return {
    type: 'CONNECT',
    connectThisNode: connectThisNode,
    toThatNode: toThatNode
  };
};

// export const connectNodeToParam = (connectThisNode, toThisParam) => ({
//   type: 'CONNECT_TO_PARAM',
//   connectThisNode,
//   toThisParam
// });

var setParam = exports.setParam = function setParam(param, value) {
  return {
    type: 'SET_PARAM',
    param: param,
    value: value
  };
};

var setValueAtTime = exports.setValueAtTime = function setValueAtTime(param, value, startTime) {
  return {
    type: 'SET_VALUE_AT_TIME',
    param: param,
    value: value,
    startTime: startTime
  };
};

var linearRampToValueAtTime = exports.linearRampToValueAtTime = function linearRampToValueAtTime(param, value, endTime) {
  return {
    type: 'LINEAR_RAMP_TO_VALUE_AT_TIME',
    param: param,
    value: value,
    endTime: endTime
  };
};

var decodeAudioData = exports.decodeAudioData = function decodeAudioData(audioData, callbackFunc) {
  return {
    type: 'DECODE_AUDIO_DATA',
    audioData: audioData,
    callbackFunc: callbackFunc
  };
};